# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class Constraint(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'type': 'str',
        'title': 'str',
        'description': 'str',
        'parameters': 'dict(str, object)'
    }

    attribute_map = {
        'id': 'id',
        'type': 'type',
        'title': 'title',
        'description': 'description',
        'parameters': 'parameters'
    }

    def __init__(self, id=None, type=None, title=None, description=None, parameters=None, _configuration=None):  # noqa: E501
        """Constraint - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._type = None
        self._title = None
        self._description = None
        self._parameters = None
        self.discriminator = None

        self.id = id
        if type is not None:
            self.type = type
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if parameters is not None:
            self.parameters = parameters

    @property
    def id(self):
        """Gets the id of this Constraint.  # noqa: E501


        :return: The id of this Constraint.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Constraint.


        :param id: The id of this Constraint.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def type(self):
        """Gets the type of this Constraint.  # noqa: E501

        the type of the constraint  # noqa: E501

        :return: The type of this Constraint.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Constraint.

        the type of the constraint  # noqa: E501

        :param type: The type of this Constraint.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def title(self):
        """Gets the title of this Constraint.  # noqa: E501

        the human-readable constraint title  # noqa: E501

        :return: The title of this Constraint.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this Constraint.

        the human-readable constraint title  # noqa: E501

        :param title: The title of this Constraint.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this Constraint.  # noqa: E501

        the human-readable constraint description  # noqa: E501

        :return: The description of this Constraint.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Constraint.

        the human-readable constraint description  # noqa: E501

        :param description: The description of this Constraint.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def parameters(self):
        """Gets the parameters of this Constraint.  # noqa: E501


        :return: The parameters of this Constraint.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this Constraint.


        :param parameters: The parameters of this Constraint.  # noqa: E501
        :type: dict(str, object)
        """

        self._parameters = parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Constraint, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Constraint):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Constraint):
            return True

        return self.to_dict() != other.to_dict()
